program rundungsfehlerfpc1;
{$mode objfpc}{$H+}

uses
  Classes, SysUtils, Math;

var
  gZfPreiseStelle: integer = 4;

//http://www.delphipraxis.net/50081-kaufmaennisch-runden.html
function PreisRunden(const Value:Extended):Extended;
var multi, X: Extended;
begin
  writeln('Value: ',Format('%.6f', [Value])); ///test

  multi := IntPower(10, gZfPreiseStelle);
  X:= Value * multi;
  Result := (Trunc(X) + Trunc(Frac(X) * 2)) / multi;
end;


var
  Netto, Brutto, StSatz: extended;
  Netto1, Brutto1, StSatz1: Currency;   //das wird mit  fpc 3.2.3 win64 nicht richtig aufgerunde
begin

  Netto:= 0.3738; // Brutto muss 0.4000 sein
  StSatz:=7;

  Brutto:= PreisRunden(Netto * ((StSatz / 100) +1));
  writeln('Brutto: ',Format('%.6f', [Brutto]));

  writeln('');

  Netto1:= 0.3738; // Brutto muss 0.4000 sein
  StSatz1:=7;

  Brutto1:= PreisRunden(Netto1 * ((StSatz1 / 100) +1));  // Hier wird die Variable als Currency
                                                         // abgeschnitten, 0.3999 wir übergeben
                                                         // Bei fpc 3.0.4(32Bit) wird nicht abgeschnitten
							 // es wird 0.399966 übergeben
  writeln('Brutto: ',Format('%.6f', [Brutto1]));

  ReadLn;

end.

